/* RTK 2009.3.3 */
#include <stdio.h>

#define MaxW 3000
#define MaxH 3000

int w, h;
int *z;
const int dx[4] = { -1, 1, 0, 0 };
const int dy[4] = { 0, 0, -1, 1 };

/* Spodnji podprogram predpostavi, da je v vrsti 1 e rep1
   polj, ki so bila nekdaj barve izBarve1, zdaj pa so barve vBarvo1.
   Ta podprogram bo poiskal e vsa druga polja, ki so dosegljiva
   iz njih po poljih barve izBarve1, jih dodal v to vrsto in jih
   prebarval v barvo vBarvo2.  Obenem bo vsa tista polja, ki
   so barve izBarve2 in mejijo na kakno polje iz vrste1,
   dodal v vrsto 2 in jih pobarval v barvo vBarvo2.  Za vrsto 2
   predpostavi, da je na zaetku prazna. */
void Pobarvaj(int *vrsta1, int *rep1, int izBarve1, int vBarvo1,
			  int *vrsta2, int *rep2, int izBarve2, int vBarvo2)
{
	int glava = 0, r1 = *rep1, r2 = 0, u, d, x, y, xx, yy, v;
	while (glava < r1)
	{
		u = vrsta1[glava++];
		x = u % w; y = u / w;
		for (d = 0; d < 4; d++)
		{
			xx = x + dx[d]; yy = y + dy[d];
			if (xx < 0 || yy < 0 || xx >= w || yy >= h) continue;
			v = w * yy + xx;
			if (z[v] == izBarve1) {
				vrsta1[r1++] = v; z[v] = vBarvo1; }
			else if (z[v] == izBarve2) {
				vrsta2[r2++] = v; z[v] = vBarvo2; }
		}
	}
	*rep1 = r1; *rep2 = r2;
}

int main(int argc, char** argv)
{
	char vrstica[MaxW + 2]; int x, y, u, *vrsta1, *vrsta2, *t, n1, n2, barva, najRed;
	FILE *f;
	/* Preberimo velikost zemljevida. */
	f = fopen("otoki.in", "rt");
	fscanf(f, "%d %d\n", &w, &h);
	/* Alocirajmo pomnilnik za zemljevid in dve vrsti. */
	z = (int *) malloc(w * h * sizeof(int));
	vrsta1 = (int *) malloc(w * h * sizeof(int)); n1 = 0;
	vrsta2 = (int *) malloc(w * h * sizeof(int));
	/* Preberimo zemljevid.  Polja na zunanjem robu dodajmo v vrsto 1. */
	for (y = 0; y < h; y++) {
		fgets(vrstica, w + 2, f);
		for (x = 0; x < w; x++) {
			u = w * y + x;
			if (x == 0 || x == w - 1 || y == 0 || y == h - 1) {
				vrsta1[n1++] = u; z[u] = 2; }
			else
				z[u] = (vrstica[x] == '#') ? 1 : 0; }}
	fclose(f);

	/* Trenutno so vsa kopna polja barve 1, vsa vodna pa barve 0,
	   razen tistih na zunanjem robu, ki so barve 2.  Pobarvajmo
	   zdaj celo morje z barvo 2, nato otoke reda 0 z barvo 3,
	   nato jezera na teh otokih z barvo 4, nato otoke reda 1 z barvo 5,
	   nato jezera na teh otokih z barvo 6, nato otoke reda 2 z barvo 7
	   in tako naprej. */
	najRed = -1; barva = 2;
	while (n1 > 0) {
		if ((barva % 2) == 1) najRed = (barva - 3) / 2;
		Pobarvaj(vrsta1, &n1, barva & 1, barva,
		         vrsta2, &n2, (barva ^ 1) & 1, barva + 1);
		t = vrsta1; vrsta1 = vrsta2; vrsta2 = t;
		u = n1; n1 = n2; n2 = n1; barva++; }

	f = fopen("otoki.out", "wt");
	fprintf(f, "%d\n", najRed);
	fclose(f);

	/* Pospravimo za sabo. */
	free(z); free(vrsta1); free(vrsta2); return 0;
}
